"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ApiError extends Error {
    constructor(code, message) {
        super(message);
        this.code = code;
        this.message = message;
        this.name = ApiError.codeToName(code);
    }
    toString() {
        return `${this.name} [${this.code}]: ${this.message}`;
    }
    static codeToName(code) {
        switch (code) {
            case "duplicate_record":
                return "DuplicateRecordError";
            case "internal_error":
                return "InternalError";
            case "invalid_request":
                return "InvalidRequestError";
            case "invalid_parameter":
                return "InvalidParameterError";
            case "missing_required_parameter":
                return "MissingRequiredParameterError";
            case "not_found":
                return "NotFoundError";
            case "unauthorized":
                return "UnauthorizedError";
            case "unknown_origin":
                return "UnknownOriginError";
            default:
                return "ApiError";
        }
    }
}
exports.default = ApiError;
